from Globals import InitializeClass
from Globals import DTMLFile
from OFS.Image  import Image, File, cookId
from Products.PageTemplates.PageTemplateFile import PageTemplateFile
#from OFS.PropertyManager import PropertyManager    
from OFS.SimpleItem import Item_w__name__
from AccessControl.Role import RoleManager
import AccessControl
#import AccessControl
from OFS.Cache import Cacheable

from ZPhotoSlidesBase import ZPhotoSlidesBaseItemWithComment
from ZPhotoSlidesUtils import *
from permissions import zphoto_apply_security
from postalcard import ZPostalCards
from Products.ZPhotoSlides.config import *
from cStringIO import StringIO
from popen2 import popen2
from zipfile import ZipFile
import os,sys
import string
import traceback

if have_PIL:
    import PIL
    from Products.ZPhotoSlides.photo_edition.image_modif import Image_modif
from Products.ZPhotoSlides.photo_edition.IM_modif import IM_Image_modif
from Products.ZPhotoSlides.photo_edition import exif
from Products.ZPhotoSlides.photo_edition import iptc

_types = {
    'PNG': 'image/png',
    'JPEG': 'image/jpeg',
    'GIF': 'image/gif',
    'BMP': 'image/x-ms-bmp',
    'PCX': 'image/pcx',
    'PPM': 'image/x-portable-pixmap',
    'TIFF': 'image/tiff',
    'ZIP': 'application/zip'
}


class PhotoJPEG:
    ''' A jpeg photo '''

    def __init__(self):
        self.show_exif = 1
        self.exif = {}
        self.iptc = {}
        self.path = ''     # fs fullpath
        self.dir = ''      # fs dir
        self.filename = '' # fs filename
        self._thumbs = {}
        self.dict_info = {}
        self.format = None
        self.tmpdir = None
        self.backup = ''

    def init_JPG(self):
        self.exif = {}
        self.dict_info = {}
        self.iptc = {}
        if self.isJPEG():
            self.exif = self._parseExif()
            self.iptc = self._parseIptc()
            if(self.exif.has_key('JPEGThumbnail')):
                del self.exif['JPEGThumbnail'] # we dont want to show
                                               # thumbnail in info
            #print self.exif
            if(self.exif.has_key('EXIF MakerNote')):
                del self.exif['EXIF MakerNote']

    def _getData(self,size='full'):
        # return data from zodb or fs
        location = self.getFormat(size)['location']
        if location == 'zodb' or ACCESS_FS == 0:
            if size == 'full':
                return self.data
            else:
                self._thumbs[size].data
        else:
            datas = -1
            if size == 'full':
                image_path = os.path.join( self.path )
            else:
                image_path = os.path.join( self.dir,'zps_thumbs','%s_%s' % (size,self.filename) )
            try:
                file = open(image_path,'rb')
            except:
                raise 'Error','No such file %s' % image_path
            datas = file.read()
            file.close()
            return datas   

    def _putData(self,data,size='full'):
        # return data from zodb or fs
        location = self.getFormat(size)['location']
        if location == 'zodb' or ACCESS_FS == 0:
            # upload
            if size == 'full':
                self.update_data(data)
            else:
                self._thumbs[size] = Image(size,self.title_or_id(),data)
        else:
            # write thumb to fs
            if size == 'full':
                image_path = os.path.join( self.dir, self.filename )
            else:
                thumbs_dir = os.path.join( self.dir,'zps_thumbs' )
                filename = '%s_%s' % (size,self.filename)
                if not os.path.isdir(thumbs_dir):
                    self._createDirectory(self.dir)
                image_path = os.path.join( thumbs_dir, filename )
                self._thumbs[size] = 'fs'
            file = open(image_path,'w')
            file.write(data)
            file.flush()
            file.close()
            self.size = len(data)
        
    def _getIm(self):
        data = StringIO(self._getData())
        try:
            img = PIL.Image.open(data)
        except:
            return 0
        return img
    
    def isJPEG(self):
        data = StringIO(self._getData())
        if(ord(data.read(1))!=0xFF):
            return 0
        if(ord(data.read(1))!=0xD8):
            return 0
        return 1

    def _getTmpDir(self):
        #acquire tmp dir or try to get it
        if not self.tmpdir:
            if hasattr(self.aq_parent,'tmpdir'):
                self.tmpdir = self.aq_parent.tmpdir
            else:
                self.tmpdir = tmp_folder
        return self.tmpdir

    def _putPreviewData(self,data):
        # write preview data
        tmpdir = self._getTmpDir()
        if tmpdir:
            image_path = os.path.join(tmpdir,'preview_%s' % self.getId())
            file = open(image_path,'w')
            file.write(data)
            file.flush()
            file.close()
            
    def _getPreviewData(self):
        # return preview data
        tmpdir = self._getTmpDir()
        if tmpdir:
            image_path = os.path.join(tmpdir,'preview_%s' % self.getId())
            file = open(image_path,'r')
            data = file.read()
            file.close()
            return data
        return None
            
    def _setTmpFile(self):
        tmpdir = self._getTmpDir()
        if tmpdir:
            tmpfile = os.path.join(tmpdir,self.getId())
            tmpfile = tmpfile + '.bak'
            self.backup = tmpfile
            file = open(tmpfile,'wb')
            file.write(self._getData())
            file.close()
            return tmpfile
        raise IOError,"Can't find Temporary directory!"

    def _parseExif(self,data=None):
        ''' Parse Exif Informations'''
        if(data==None):
            data = self._getData()
        return exif.process_file(StringIO(data))

    def _parseIptc(self,data=None):
        ''' Parse IPTC Informations'''
        if(data==None):
            data = self._getData()
        return iptc.getiptc_data(data)

    def getExif(self):
        ''' return Exif infos '''
        return self.exif

    def hasExifOrIptc(self):
        ''' return if there is iptc or exif info inside the photo'''
        return (bool(self.exif) or bool(self.iptc))

    def getExifAndIptc(self):
        ''' return Exif and IPTC infos '''
        dict = self.exif
        for key in self.iptc:
            dict[key] = self.iptc[key]
        return dict

    def showExif(self):
        ''' return if we use Exif infos '''
        if hasattr(self.aq_parent,'show_exif'):
            return self.aq_parent.show_exif
        else:
            return self.show_exif

    def getIptc(self):
        ''' return Iptc infos '''
        return self.iptc
        
    def getInfos(self,key=None):
        if(self.dict_info=={}): # avoid getting info several time with the same result...
            if(self.lib == 'PIL'):
                tmpfile = self._setTmpFile()
                #print 'temp file is: %s' % tmpfile 
                img = Image_modif(tmpfile)
            else:
                img = IM_Image_modif(self.convert,self._getData())
            self.dict_info = img.get_info()
        if key:
                if self.dict_info.has_key(key): return self.dict_info[key]
                else: return ''
        else:
	    return self.dict_info

class Photo(PhotoJPEG):
    ''' A Photo with thumbnails'''

 #   manage_main = Image.manage_main
    manage_options = Image.manage_options

    def __init__(self):
        PhotoJPEG.__dict__['__init__'](self) #__init__(self)
        self.sizes = DEFAULT_SIZES
        self.size = 0
        self.default_size = 'full'
        self.getviewit = 1
        self.viewed = 0
        self.keywords = []
        self.convert = None

    def getKeywords(self):
        "return the list of keywords as a string"
        cpt = 0
        string = ''
        for elem in self.keywords:
            if(cpt == 0):
                string = elem
            else:
                string = string + ', ' + str(elem).strip()
            cpt= cpt +1
        return string

    def update_data_from_fs(self,image,upload=1,REQUEST=None):
        #read a file from fs
        if(ACCESS_FS==1):
            self.lib = get_img_lib(self.aq_parent)
            location = self.getFormat('full')['location']
            if location == 'zodb':
                file = open(image,'rb')
                data = file.read()
                file.close()
                self.update_data(data)
            self.path = image
            self.init_JPG()
            if self.lib:
                self._pre_thumbnailize()
            if REQUEST:
                if self.portal_type: view = 'view'
                else: view = 'manage_main'
                return REQUEST.RESPONSE.redirect( '%s/%s' %
                (self.absolute_url(),view) )
            else:
                return 1
        else:
            if(REQUEST):
                return REQUEST.RESPONSE.redirect('%s/%s&zps_message="No FS Access"' % (self.absolute_url(),edit))
            else:
                return -1

    def get_size(self):
        '''return the size of an object'''
        return len(self._getData())

    def manage_upload(self,file,REQUEST=None):
        ''' upload file 
        & del thumbnails
        '''
        self.lib = get_img_lib(self.aq_parent)
        for i in self._thumbs.keys():
            del self._thumbs[i]
        self.path = ''
        #file.seek(0)
        fdata = file.read()
        if self.filename == '': self.filename = self.getId()
        if self.dir == '':
            if hasattr(self.aq_parent,'photo_folder'):
                self.dir = self.aq_parent.photo_folder
            else:
                self.dir = ''
        if self.dir and self.filename: self.path = os.path.join(self.dir,self.filename)
        self._putData(fdata)
        self.init_JPG()
        self._pre_thumbnailize()
        if REQUEST:
            if self.portal_type: view = 'view'
            else: view = 'manage_main'
            return REQUEST.RESPONSE.redirect( '%s/%s' % (self.absolute_url(),view) )
        
    def _pre_thumbnailize(self):
        # reinit sizes from parent if possible
        self.sizes = {}
        for f in self.getFormats(only_used=1):
            self.sizes[f['name']] = f['size']
            
        # delete thumbs if any
        if self._thumbs:
            # delete each key to clean ZODB
            oldsizes = self._thumbs.keys()
            for s in oldsizes:
                del self._thumbs[s]
            self._thumbs = {}
        
        # generate thumbs for all sizes
        for name,size in self.sizes.items():
            if name not in ('full',):
                try:
                    self._thumbnailize(name,size,size)
                except:
                    pass
    def export(self,format,newwidth,newheight,zip,REQUEST={}):
        "export a photo to a defined format"
        name,ext = os.path.splitext(self.filename)
        newfilename = name + '.' + string.lower(format)
        if self.lib == 'PIL':
            file = self._exportPIL(format,newwidth,newheight)
        if self.lib == 'IM':
            file = self._exportIM(format,newwidth,newheight)
        if(int(zip)==1):
                file = self._getZipFile(file,newfilename)
                format = 'ZIP'
                newfilename = '%s.zip' % newfilename
        if(REQUEST!={}):
            REQUEST.RESPONSE.setHeader('Content-Type',_types[format])
            REQUEST.RESPONSE.addHeader("Content-Disposition","filename=%s" % newfilename)
            REQUEST.RESPONSE.setHeader('Content-Length',len(file))
            REQUEST.RESPONSE.write(file)
        else:
            return newfilename,file
    def sizeList(self):
        "return the list of sizes made for this photos"
        return self._thumbs.keys()

    def _getZipFile(self,data,filename):
        sIO = StringIO()
        zip = ZipFile(sIO,"w",8)
        zip.writestr(filename,data)
        zip.close()
        return sIO.getvalue()
        
    def _exportPIL(self,format,newwidth,newheight):
        name,ext = os.path.splitext(self.filename)
        newfilename = name + '.' + format
        try:
            imgio = StringIO()
            pil_img = PIL.Image.open(StringIO(self._getData()))
            if(int(newwidth)!=0 or int(newheight)!=0):
                if(int(newwidth) == 0):
                    newwidth = self.width
                if(int(newheight) == 0):
                    newheight = self.height
                pil_img.thumbnail((int(newwidth),int(newheight)))
                pil_img.save(imgio,format)
                return imgio.getvalue()
            else: # no need to thumbnail we want original
                return self._getData()
        except:
            print traceback.print_exc()
            return None

    def _exportIM(self,format,newwidth,newheight):
        name,ext = os.path.splitext(self.filename)
        newfilename = name + '.' + format
        try:
            IM_Image_modif(self.convert,self._getData())
            img = IM_Image_modif(self.convert,self._getData())
            if(int(newwidth)!=0 or int(newheight)!=0):
                if(int(newwidth) == 0):
                    newwidth = self.width
                if(int(newheight) == 0):
                    newheight = self.height
                return img.export(format,int(newwidth),int(newheight)).getvalue()
            else: # no need to thumbnail we want original formats!
                return self._getData()
        except:
            print traceback.print_exc()
            return None


    def _thumbnailize(self,size='thumb',width=200,height=200):
        if self.lib == 'PIL': 
            image = self._resizePIL(width=width,height=height)
            if not image:
                image = self._resizeIM(width=width,height=height)
        elif self.lib == 'IM':
            image = self._resizeIM(width=width,height=height)
            if not image:
                image = self._resizePIL(width=width,height=height)
        else:
            raise 'LibrairyError', 'No image lib available'
        if image:
            self._putData(image,size)
            return 0
        else:
            print 'Error while thumbnailizing %s %s' % (self.getId(),size)
            return -1

    def _resizePIL(self,width=200,height=200):
        try:
            imgio = StringIO()
            data = self._getData()
            if data:
                pil_img = PIL.Image.open( StringIO(data) )
                format = pil_img.format
                pil_img.thumbnail((width,height))
                pil_img.save(imgio,format)
                return imgio.getvalue()
            else:
                return None
        except:
            print traceback.print_exc()
            return None
        
    def _resizeIM(self,width=200,height=200):
        #try:
            imgio = StringIO()
            data = self._getData()
	     # try to find convert, does it exist?
            #print 'convert is: %s' % self.convert
	    if(not os.access(self.convert,os.X_OK)):
		return None
            if data:
                #command = '%s -geometry %ix%i -interlace LINE - -' % (self.convert,width,height)
                command = '%s -geometry %ix%i - -' % (self.convert,width,height)
                if sys.platform == 'win32':
                    from win32pipe import popen2
                    stdin, stdout = popen2(command, 'b')
                else:
                    from popen2 import Popen3
                    convert=Popen3(command)
                    stdout=convert.fromchild
                    stdin=convert.tochild
                #stdout,stdin = popen2(command)
                stdin.write(data)
                stdin.close()
                imgio.write(stdout.read())
                stdout.close()
                return imgio.getvalue()
            else:
                return None
        #except:
        #    return None
        
    def doTransform(self,REQUEST,preview=0,redirect=1):
        ''' Modify an image '''
        tmpfile = self._setTmpFile()
        if(self.lib =='PIL'):
            img = Image_modif(tmpfile)
            (img, modif) = img.modify_from_request(img,REQUEST)
            imgio = StringIO()
            format = img.format
            img.im.save(imgio,format)
        if(self.lib =='IM'):
            img = IM_Image_modif(self.convert,self._getData())
            (img,modif) = img.modify_from_request(REQUEST)
            imgio = img
        if preview:
            self._putPreviewData(imgio.getvalue())
        else:
            #self.update_data(imgio.getvalue())
            self._putData(imgio.getvalue())
            self._thumbs = {}
            self.dict_info = {}
            self._pre_thumbnailize()
            self.init_JPG()
            if(redirect):
                return REQUEST.RESPONSE.redirect('%s/zphoto_edit_form?&zps_message=%s' %
                                    (self.absolute_url(),'Modification done!'))
    def doPreview(self,REQUEST):
        ''' Modify a preview image '''
        self.doTransform(REQUEST,preview=1)
        show_both= REQUEST.get('show_both',0)
        return REQUEST.RESPONSE.redirect('%s/zps_popup?macro=preview&show_both=%s' % (self.absolute_url(),show_both))

    def undoable_transactions(self, first_transaction=None,
                              last_transaction=None,
                              PrincipiaUndoBatchSize=None):
        print "dont want to be undoable!"
        pass

    def undoTransform(self,REQUEST,preview=0):
        ''' undo modify of an image '''
	backup = self.backup
        #print "fetching %s" % backup
	if os.path.exists(backup):
            fd = open(backup,'rb')
            data = fd.read()
            self._putData(data)
            fd.close()
            self._thumbs = {}
            self._pre_thumbnailize()
            self.init_JPG()
            #self.update_data_from_fs(backup)
	    os.remove(backup)
            return REQUEST.RESPONSE.redirect('%s/zphoto_edit_form?zps_message=%s' %
                                    (self.absolute_url(),'Undo successfull !'))
	else:
            return REQUEST.RESPONSE.redirect('%s/zphoto_edit_form?zps_message=%s' %
                                    (self.absolute_url(),"Sorry, undo can't be done for this image."))
            
    def getViewed(self):
        ''' return viewed '''
        return self.viewed

    def getShow(self):
        ''' return viewable image'''
        return self.getviewit

    def showExport(self):
        ''' show the export tab '''
        return self._ac_attr('show_export')

    def manage_edit(self, title, content_type, precondition='',
                    filedata=None, REQUEST=None):
        """
        Changes the title and content type attributes of the File or Image.
        """
        if(REQUEST.default_size in self.sizeList()):
            self.default_size = str(REQUEST.default_size)
        self.show_exif = int(REQUEST.show_exif)
        self.keywords=[]
        for elem in string.split(REQUEST.keywords,','):
            self.keywords.append(string.strip(elem))
        self.title=str(title)
        self.content_type=str(content_type)
        if precondition: self.precondition=str(precondition)
        elif self.precondition: del self.precondition
        if filedata is not None:
            self.update_data(filedata, content_type, len(filedata))
        else:
            self.ZCacheable_invalidate()
        if REQUEST:
            message="Saved changes."
            return REQUEST.RESPONSE.redirect('%s/manage_main?zps_message=%s' %
                                    (self.absolute_url(),message))
    
    def getSizes(self):
        ''' return sizes string
        orderer by values'''
        s = [(f['size'], f['name']) for f in self.getFormats(only_used=1)]
        s.sort()
        return [k for (v, k) in s]
   
    def index_html(self,size=None,REQUEST=None):
        ''' index_html 
        return photo or thumbnail '''
        if REQUEST:

            if size == 'preview':
                # get transform preview

                # avoid image cache in browser
                REQUEST.RESPONSE.setHeader('Pragma', 'no-cache')
                REQUEST.RESPONSE.setHeader('Expire', 'Sat, 1 Jan 2000 00:00:00 GMT')
                
                # get the image
                try:
                    data = self._getPreviewData()
                except:
                    return getattr(self.misc_.ZPhotoSlides,'zps_unknow.gif').index_html(REQUEST,REQUEST.RESPONSE)
                if data:
                    return Image(self.getId(),'Preview',data).index_html(REQUEST,REQUEST.RESPONSE)
                else:
                    return getattr(self.misc_.ZPhotoSlides,'zps_unknow.gif').index_html(REQUEST,REQUEST.RESPONSE)
                
            if not size: size = self.getDefaultSize()
            if size not in ('thumb',): 
                if(not REQUEST.cookies.has_key('visited'+str(self.getId()))):
                    self.viewed = self.viewed + 1
                    REQUEST.RESPONSE.setCookie('visited'+str(self.getId()),1)
            # get image from fs
            location = self.getFormat(size)['location']
            if location == 'fs' and ACCESS_FS == 1:
                try:
                    data = self._getData(size)
                except:
                    return getattr(self.misc_.ZPhotoSlides,'zps_unknow.gif').index_html(REQUEST,REQUEST.RESPONSE)
                if data:
                    return Image(self.getId(),self.title_or_id(),data).index_html(REQUEST,REQUEST.RESPONSE)
                else:
                    return getattr(self.misc_.ZPhotoSlides,'zps_unknow.gif').index_html(REQUEST,REQUEST.RESPONSE)
            # get image from zodb
            if size == 'full':
                return Image.index_html(self,REQUEST,REQUEST.RESPONSE)
            else:
                if self.sizes.has_key(size):
                    return Image.index_html(self._thumbs[size],REQUEST,REQUEST.RESPONSE)
                else:
                    return getattr(self.misc_.ZPhotoSlides,'zps_unknow.gif').index_html(REQUEST,REQUEST.RESPONSE)

    def tag(self,size=None,scale='full',REQUEST=None):
        ''' tag 
        return photo or thumbnail tag '''
        xhtml = 'class="zps_image" oncontextmenu="javascript:return false;"'
        if not size: size = self.getDefaultSize()
        if size not in ('thumb',):
            if(REQUEST):
                if(not REQUEST.cookies.has_key('visited'+str(self.getId()))):
                    self.viewed = self.viewed + 1
                    REQUEST.RESPONSE.setCookie('visited'+str(self.getId()),1)
        if size == 'full':
            im = self
        else:
            if self.sizes.has_key(size):
                res = 0
                if not self._thumbs.has_key(size):
                    res = self._thumbnailize(size,self.sizes[size],self.sizes[size])
                if(res == -1): # we got error while thumbnailizing =( just show full image
                    im = self
                    size = 'full'
                    self.default_size = 'full'
                else:
                    im = self._thumbs[size]
            else:
                return '<img src="%s/?size=%s" alt="%s" border="0" %s />' % (self.absolute_url(),size,self.title_or_id(),xhtml)
        # We can't have the width,height if image is on fs
        # width,height = im.width,im.height
        # return '<img src="%s?size=%s" alt="%s" width="%i" height="%i" border="0"/>' % (self.absolute_url(),size,self.title_or_id(),width,height)
        return '<img src="%s?size=%s" alt="%s" border="0" %s />' % (self.absolute_url(),size,self.title_or_id(),xhtml)
            
def manage_addZPhoto(self,id,title='',file='',path=''):
    ''' add ZPhoto '''
    img = ZPhoto(id,title,'')
    self._setObject(id,img)
    zp = self._getOb(id)
    #print 'set default size: %s' % zp.getDefaultSize()
    img.default_size = zp.getDefaultSize()
    zp.init_position()
    # get convert path from parent
    zp.convert = self.convert
    if file:
        zp.manage_upload(file)
    if path:
        zp.update_data_from_fs(path)

class ZPhoto(Photo,ZPhotoSlidesBaseItemWithComment,ZPostalCards,Image):
    ''' ZPhoto '''

    meta_type = 'ZPhoto'
    portal_type = None
    isPrincipiaFolderish = 0

    __implements__ = ( Image.__implements__ ,)

    security = AccessControl.ClassSecurityInfo()
    zphoto_apply_security(security,'View','View management screens')
    manage_main = PageTemplateFile('skins/zphotoslides/zphoto_properties',globals())
    main_template = PageTemplateFile('zpt/main_template',globals()) 
    header = PageTemplateFile('zpt/header',globals()) 
    view_image_or_file = PageTemplateFile('skins/zphotoslides/zphoto_view',globals()) 
    zphoto_view = PageTemplateFile('skins/zphotoslides/zphoto_view',globals())
    view = PageTemplateFile('skins/zphotoslides/zphoto_view',globals())
    zphoto_edit_form = PageTemplateFile('skins/zphotoslides/zphoto_edit_form',globals()) 
    zphoto_ratings = PageTemplateFile('skins/zphotoslides/zphoto_ratings',globals())
    zphoto_export = PageTemplateFile('skins/zphotoslides/zphoto_export',globals())
    #ratings_view = PageTemplateFile('skins/zphotoslides/ratings_view',globals())
    postcard = PageTemplateFile('skins/zphotoslides/postcard',globals())
    about = PageTemplateFile('skins/zphotoslides/abouts',globals())
    getcomment = DTMLFile('dtml/getcomment',globals())
    manage_options=(
                (
                    {'label':'Edit', 'action':'manage_main',
                                 'help':('OFSP','File_Edit.stx')},
                    {'label':'View', 'action':'zphoto_view',
                                 'help':('OFSP','File_View.stx')},
                    {'label':'View album','action':'view_album'},
                    {'label':'Modify Photo','action':'zphoto_edit_form'},
                                                          )
                        # user can't modify properties by hand
                        #+ PropertyManager.manage_options
                        + RoleManager.manage_options
                        + Item_w__name__.manage_options
                        + Cacheable.manage_options
                        +({'label': "About this product",   'action': 'about'},)
                )

    def __init__(self,id,title='',file=''):
        try:
            Photo.__init__(self)
            ZPhotoSlidesBaseItemWithComment.__init__(self)
            ZPostalCards.__init__(self)
            Image.__init__(self,id,title,file,'')
        except:
            Photo.__dict__['__init__'](self) #__init__(self)
            ZPhotoSlidesBaseItemWithComment.__dict__['__init__'](self) #__init__(self)
            ZPostalCards.__dict__['__init__'](self) #__init__(self)
            File.__dict__['__init__'](self,id,title,file,'') #__init__(self,id,title,file,'')
        self._thumbs = {}
        self.update_date = '10/10/04'

    def view_album(self,REQUEST=None):
        ''' redirect to parent '''
        if REQUEST:
            REQUEST.RESPONSE.redirect(self.aq_parent.absolute_url())

    def undoable_transactions(self, first_transaction=None,
                              last_transaction=None,
                              PrincipiaUndoBatchSize=None):
        print "dont want to be undoable!"
        pass


InitializeClass(ZPhoto)
