# ZPhotoSlides, Zope product
# Copyright (C) 2002-2003  Jean-Francois Roche <jfroche@jfroche.be>
#                          Florent Carlier <florent.carlier@insa-rennes.fr>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
# $Id: __init__.py,v 2.9 2004/08/26 12:55:45 jfroche Exp $'

__author__="""Jean-Francois Roche (jfroche@jfroche.be)"""
__doc__="""Z Photos Slides Initialisation"""
__version__='$Revision: 2.9 $'[11:-2]


from AccessControl import ModuleSecurityInfo, ClassSecurityInfo, allow_class


import ZPhotoSlidesUtils
from ZPSPloneBatch import Batch

allow_class(Batch)

import ZPhoto
import ZPhotoSlides
import ZPhotoSlidesFolder

install_globals = globals() # Used only in the Extensions/Install.py script

#Out of try/except for debuging
#import CMFPhoto,CMFPhotoSlides,CMFPhotoSlidesFolder
try:
    import CMFPhoto,CMFPhotoSlides,CMFPhotoSlidesFolder
    from Products.CMFCore.DirectoryView import registerDirectory 
    from Products.CMFCore import utils, CMFCorePermissions
except: 
    have_cmf = 0 
else: 
    have_cmf = 1

misc_ = {}
def initialize(context):
        context.registerClass(
            ZPhotoSlides.ZPhotoSlides,
            constructors=(ZPhotoSlides.manage_addZPhotoSlidesForm,ZPhotoSlides.manage_addZPhotoSlides),
            permissions=('ZPhotoSlides: Add ZPhotoSlides',),
            icon='www/photo.gif'
            )
        context.registerClass(
            ZPhoto.ZPhoto,
            constructors=(ZPhoto.manage_addZPhoto,),
            permissions=('ZPhotoSlides: Add ZPhotoSlides',),
            icon='www/photo.gif',
            visibility=None,
            )
        context.registerClass(
            ZPhotoSlidesFolder.ZPhotoSlidesFolder,
            constructors = (ZPhotoSlidesFolder.manage_addZPhotoSlidesFolderForm, ZPhotoSlidesFolder.manage_addZPhotoSlidesFolder),
            permissions=('ZPhotoSlides: Add ZPhotoSlides',),
            icon = 'www/photofolder.gif'
            )
        context.registerHelp()
        context.registerHelpTitle('ZPhotoSlides')
	registerIcon('arrowUp.gif')
	registerIcon('arrowDown.gif')
        registerIcon('carte1.jpg')
        registerIcon('timbre.jpg')
        registerIcon('carte_ligne.gif')
        registerIcon('mainbar.gif')
        registerIcon('orient1.gif')
        registerIcon('orient2.gif')
        registerIcon('orient3.gif')
        registerIcon('zps_unknow.gif')

        if(have_cmf == 1): 
            #registerDirectory('zpt', globals())
            registerDirectory('skins', globals())
            registerDirectory('skins/zphotoslides', globals())
            contentClasses = (CMFPhoto.ZPhoto,
                              CMFPhotoSlides.ZPhotoSlides,
                              CMFPhotoSlidesFolder.ZPhotoSlidesFolder, )
            contentConstructors = (CMFPhoto.addZPhoto,
                                   CMFPhotoSlides.addZPhotoSlides,
                                   CMFPhotoSlidesFolder.addZPhotoSlidesFolder, ) 
            fti = (CMFPhoto.factory_type_information,
                   CMFPhotoSlides.factory_type_information,
                   CMFPhotoSlidesFolder.factory_type_information, ) 
            utils.ContentInit(
                 'CMF ZPhotoSlides',
                 content_types = contentClasses, 
                 permission = 'ZPhotoSlides: Add ZPhotoSlides',
                 extra_constructors = contentConstructors,
                 fti = fti,
                 ).initialize(context) 

import OFS, App

def registerIcon(filename, idreplacer={}):
	objectid = filename
	for k,v in idreplacer.items():
		objectid= objectid.replace(k,v)
	setattr(OFS.misc_.misc_.ZPhotoSlides,
	        objectid,
		App.ImageFile.ImageFile('www/%s' % filename, globals())
		)

