from AccessControl.Permission import registerPermissions

#
# Postcards methods
#

postcard_send_method = (
        'sendPostcard',
        'sendNotification',
       ) 

postcard_view_method = (
        'addPostcard',
        'getPostcard',
        'countPostcards',
        )

postcard_manage_method = (
        'getPostcards',
        'delPostcards',
        )
#
# OrdererItem methods
#

orderer_view_method = (
        'getNav',
        'getNextItem',
        'getPrevItem',
        )

orderer_manage_method = (
        'init_position',
        'moveDown',
        'moveUp',
        )

#
# PhotoSlidesBaseItem methods
#

photoslidebaseitem_view_method = (
        'getDefaultSize',
        'getFormat',
        'getFormats',
        'number_of_comments',
        'showComments',
        'getManagerMail',
        'getSizes',
        'showARPostcard',
        'showPostcard',
        ) + orderer_view_method

photoslidebaseitem_manage_method = (
        'needupgrade',
        'upgrade',
        ) + orderer_manage_method

#
# RateItem methods
#

rate_view_method = (
        'doRating',
        'getRating',
        'getRatingFolder',
        'showRatings',
        )

rate_manage_method = (
        'delRating',
        )

#
# SkinnedItem methods
#

skin_view_method = (
        'header',
        'main',
        )

skin_manage_method = (
        'isSkinned',
        'manage_changeColors',
        'manage_delSkin',
        'manage_editCSS',
        'manage_editMainTemplate',
        'manage_restoreCSS',
        'manage_restoreColors',
        'manage_restoreSkin',
        'manage_restoreZpt',
        'manage_skin',
        )

#
# CommentItem methods
#

comment_view_method = (
        'addComment',
        'countComments',
        'getComments',
        'hasComment',
        'showComments',
        'zps_comments',
        )

comment_manage_method = (
        'delComments',
        'editComment',
        'manage_edit_comments',
        )

#
# Photo methods
#

#common photo view method
photo_view_method = (
        'showPostcard',
        'isJPEG',
        'getExif',
        'showExif',
        'getIptc',
        'getInfos',
        'getViewed',
        'getSizes',
        'getDefaultSize',
        'index_html',
        'tag',
        ) + photoslidebaseitem_view_method + rate_view_method + postcard_view_method

#common photo manage method
photo_manage_method = (
        'manage_main',
        'init_JPG',
        'update_data_from_fs',
        'manage_upload',
        'doTransform',
        'undoTransform',
        'delRating',
        ) + photoslidebaseitem_manage_method + rate_manage_method + postcard_manage_method

#zphoto specific private method
zphoto_private_method = (
        ) 

#zphoto specific view method
zphoto_view_method = (
        'zphoto_view',
        'zphoto_ratings',
        'view_album',
        ) + photo_view_method + comment_view_method

#zphoto specific manage method
zphoto_manage_method = (
        'zphoto_edit_form',
        ) + photo_manage_method + comment_manage_method

#cmfphoto specific private method
cmfphoto_private_method = (
        ) 

#cmfphoto specific view method
cmfphoto_view_method = (
        'SearchableText',
        ) + photo_view_method

#cmfphoto specific manage method
cmfphoto_manage_method = (
        ) + photo_manage_method


#
# PhotoSlides methods
#

#private photoslides method
photoslides_private_method = (
        'breadcrumb',
        'manage_afterAdded',
        'manage_addFS',
        'postcard_mail',
        'postcardNotif_mail',
        'postcardAR_mail',
        'generateId',
        'encodemail',
        'remove_photos_server',
        'remove_thumbnails_from_disk',
        'update_cache',
        'validEmail',

        )

#common photoslides view method
photoslides_view_method = (
        'parse_ext',
        'get_rating_all',
        'get_rating_list',
        'get_rating',
        'get_ratingfolder',
        'getThumb',
        'getThumbTag',
        'getSymbolicTag',
        'getSlide',
        'getBatch',
        'imagesValues',
        'countImages',
        'imagesIds',
        'give_header_4_robots',
        'getSlideShowContents',
        'get_iptc_infos',
        'get_exif_infos',
        'get_keywords',
        'get_image_info',
        'get_nbr_non_hidden_thumb',
        'number_of_ratings',
        ) + photoslidebaseitem_view_method + rate_view_method

#photoslides common manage method
photoslides_manage_method = (
        'rate_content',
        'visited',
        'getIPTCPropName',
        'choose_symbolic_photo',
        'getPostcards',
        'delete_rating',
        'amount_photos',
        'manage_edit',
        'makeThumbs',
        'back_from_form',
        'view_preview',
#        'image_modif',
        'undo_modif',
        'viewable_images',
        'get_ordered_visits',
        'visits_this_month',
        'visits_today',
        'total_visits',
        'folder_delete',
        ) + photoslidebaseitem_manage_method + rate_manage_method

#zphotoslides specific view method
zphotoslides_private_method = (
        'manage_updateMailHost',
        ) + photoslides_private_method

#zphotoslides specific view method
zphotoslides_view_method = (
        'view',
        'index_html',
        'view_card',
        'view_movie',
        'view_photo',
        'slide_show',
        'slide_show_js',
        'ratings_box',
        'ratings_view',
        'zphotoslides_header',
        'zps_batch_macros',
        ) + photoslides_view_method + skin_view_method + comment_view_method

#zphotoslides specific manage method
zphotoslides_manage_method = (
        'edit_image',
        'add_new_photo',
        'add_photos',
        'edit_photo',
        'manage_ratings',
        'manage_tabs',
        'preview_modif',
        'zphotoslides_contents',
        'zphotoslides_edit_form',
        'abouts',
        ) + photoslides_manage_method + skin_manage_method + comment_manage_method

#cmfphotoslides private method
cmfphotoslides_private_method = (
        'have_stripogram',
        'have_localizer',
        'have_PIL',
        'have_IM',
        'tmp_folder',
       ) + photoslides_private_method

#cmfphotoslides specific view method
cmfphotoslides_view_method = (
        'SearchableText',
        ) + photoslides_view_method

#cmfphotoslides specific manage method
cmfphotoslides_manage_method = (
        'add_new_photo',
        ) + photoslides_manage_method


#
# PhotoSlidesfolder methods
#

#private photoslidesfolder method
photoslidesfolder_private_method = (
        )

#common photoslides view method
photoslidesfolder_view_method = (
        ) + photoslidebaseitem_view_method + rate_view_method

#photoslides common manage method
photoslidesfolder_manage_method = (
        ) + photoslidebaseitem_manage_method + rate_manage_method

#zphotoslides specific view method
zphotoslidesfolder_private_method = (
        ) + photoslidesfolder_private_method

#zphotoslides specific view method
zphotoslidesfolder_view_method = (
        ) + photoslidesfolder_view_method + skin_view_method + comment_view_method

#zphotoslides specific manage method
zphotoslidesfolder_manage_method = (
        ) + photoslidesfolder_manage_method + skin_manage_method + comment_manage_method

#cmfphotoslides private method
cmfphotoslidesfolder_private_method = (
        'have_stripogram',
        'have_localizer',
        'have_PIL',
        'have_IM',
        'tmp_folder',
       ) + photoslidesfolder_private_method

#cmfphotoslides specific view method
cmfphotoslidesfolder_view_method = (
        'SearchableText',
        ) + photoslidesfolder_view_method

#cmfphotoslides specific manage method
cmfphotoslidesfolder_manage_method = (
        ) + photoslidesfolder_manage_method

# set ZPhotoSlides new permissions
addZPhotoSlides = 'ZPhotoSlides: Add ZPhotoSlides'
exportPhoto = 'ZPhotoSlides: Export photo'
usePostcard = 'ZPhotoSlides: Use postcard'
sendPostcard = 'ZPhotoSlides: Send postcard'

registerPermissions(
        ( 
            (addZPhotoSlides,(),('Manager', 'Owner')),
            (exportPhoto,(),('Manager', 'Owner')),
            (usePostcard,(),('Manager', 'Owner')),
            (sendPostcard,(),('Manager', 'Owner')),
        )
    )
try:
    from Products.CMFCore.CMFCorePermissions import setDefaultRoles
    setDefaultRoles( addZPhotoSlides, ('Manager', 'Owner') )
    setDefaultRoles( exportPhoto, ('Manager', 'Owner') )
    setDefaultRoles( usePostcard, ('Manager', 'Owner') )
    setDefaultRoles( sendPostcard, ( 'Authenticated', 'Member', 'Manager', 'Owner') )
except:
    pass


# security methode to update object permissions
def zphoto_apply_security(security,view_perm,manage_perm):
    perms = (
              (zphoto_view_method,view_perm),
              (zphoto_manage_method,manage_perm),
              (zphoto_private_method,'private'),
              (postcard_send_method,sendPostcard),
              ( ('export',) , exportPhoto ),
            )
    apply_security(security,perms)
    
def cmfphoto_apply_security(security,view_perm,manage_perm):
    perms = (
              (cmfphoto_view_method,view_perm),
              (cmfphoto_manage_method,manage_perm),
              (cmfphoto_private_method,'private'),
              (postcard_send_method,sendPostcard),
              ( ('export',) , exportPhoto ),
            )
    apply_security(security,perms)

def zphotoslides_apply_security(security,view_perm,manage_perm):
    perms = (
              (zphotoslides_view_method,view_perm),
              (zphotoslides_manage_method,manage_perm),
              (zphotoslides_private_method,'private'),
              ( ('export',) , exportPhoto ),
            )
    apply_security(security,perms)
    
def cmfphotoslides_apply_security(security,view_perm,manage_perm):
    perms = (
              (cmfphotoslides_view_method,view_perm),
              (cmfphotoslides_manage_method,manage_perm),
              (cmfphotoslides_private_method,'private'),
              ( ('export',) , exportPhoto ),
            )
    apply_security(security,perms)
    
def zphotoslidesfolder_apply_security(security,view_perm,manage_perm):
    perms = (
              (zphotoslidesfolder_view_method,view_perm),
              (zphotoslidesfolder_manage_method,manage_perm),
              (zphotoslidesfolder_private_method,'private'),
            )
    apply_security(security,perms)
    
def cmfphotoslidesfolder_apply_security(security,view_perm,manage_perm):
    perms = (
              (cmfphotoslidesfolder_view_method,view_perm),
              (cmfphotoslidesfolder_manage_method,manage_perm),
              (cmfphotoslidesfolder_private_method,'private'),
            )
    apply_security(security,perms)
    
def apply_security(security,perms):
    for (methodes,perm) in perms:
        if perm == 'private':
            for m  in methodes:
                security.declarePrivate(m)
        elif perm == 'public':
            for m  in methodes:
                security.declarePublic(m)
        else:
            for m  in methodes:
                security.declareProtected(perm,m)
        
