# ZPhotoSlides, Zope product
# Copyright (C) 2002-2003  Jean-Francois Roche <jfroche@jfroche.be>
#                          Florent Carlier <florent.carlier@insa-rennes.fr>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
# $Id: postalcard.py,v 2.3 2004/10/07 19:25:20 jfroche Exp $'


from OFS.SimpleItem import SimpleItem
from Globals import DTMLFile
from Products.PageTemplates.PageTemplateFile import PageTemplateFile

from stat import ip_log
import time,random

class PostCard(SimpleItem):
    ''' A published postcard '''
    def __init__(self,photo,id,name_to,email_to,name_from,email_from,commt,date,AR,size,ip):
        self.id = id
        #print "adding ip : " + ip
        self.photo_url = photo.absolute_url()
        self.photo_id = photo.getId()
	self.adrip = ip
	self.name_to = name_to
	self.email_to = email_to
	self.name_from = name_from
	self.email_from = email_from
        self.comment = commt
        self.date = date
	self.AR = AR
	#print "new size:" + size
	self.size = size

    def _setRequest(self,REQUEST):
        REQUEST.set('card_id',self.id)
        REQUEST.set('name_to',self.name_to)
        REQUEST.set('email_to',self.email_to)
        REQUEST.set('name_from',self.name_from)
        REQUEST.set('email_from',self.email_from)
        REQUEST.set('comment',self.comment)
        REQUEST.set('times',self.date)
        REQUEST.set('date',self.date)
        return REQUEST
    
class PostalCards:
    ''' The postcard system '''
    
    def __init__(self):
        self.listecard = {}
        self.show_postcard = 0
        self.show_ARpostcard = 0
        
    def addPostcard(self,name_to,email_to,name_from,email_from,commt,date,AR,size,REQUEST):
        ''' add a PostCard '''
        ip = ip_log(REQUEST)
        id = time.strftime('%Y%s%d%H%M%S', time.localtime()) + str(random.random())[4:]
        dictcard = PostCard(self,id,name_to,email_to,name_from,email_from,commt,date,AR,size,ip)
        self.listecard[id] = dictcard
        return dictcard
        
    def delPostcards(self,ids,REQUEST=None):
        ''' del a PostCard by id '''
        if ids:
            for id in ids:
                if id and self.listecard.has_key(id):
                    del self.listecard[id]
            message = 'Postcards have been deleted: %s' % ' '.join(ids)
        else:
            message = 'You must selected one or more postcards to delete.'
        if REQUEST:
            return REQUEST.RESPONSE.redirect( '%s/manage_postcards?zps_message=%s' % (self.absolute_url(),message) )
            
    def getPostcard(self, id):
        ''' return a PostCard by id '''
        if id and self.listecard.has_key(id):
            return self.listecard[id]
        else:
            None
        
    def getPostcards(self):
        ''' return all PostCard order by date desc '''
        liste = [(v.date,v) for v in self.listecard.values()]
        liste.sort()
        liste.reverse()
        return [v for (d,v) in liste]
        
    def countPostcards(self):
        '''Say if the postcard list is empty'''
        if self.listecard:
            return len(self.listecard.keys())
        return 0
    
    def _setMailHeader(self,REQUEST,name_from,email_from,name_to,email_to,subject):
        REQUEST.set('name_from',name_from)
        REQUEST.set('email_from',email_from)
        REQUEST.set('name_to',name_to)
        REQUEST.set('email_to',email_to)
        REQUEST.set('subject',subject)
        return REQUEST
    
    def sendNotification(self,card,REQUEST):
        if(card.AR == 1):
            card._setRequest(REQUEST)
            # get body of text before header modification
            REQUEST.set('post_type','AR')
            mail_text = self.postcard_text(REQUEST=REQUEST)
            print REQUEST
            print mail_text
            # header
            # manager
            name_from = 'Postcard Bot'
            email_from = self.getManagerMail()
            # it's a notification: to => from
            name_to = card.name_from
            email_to = card.email_from
            subject = 'Postcard visited'
            self._setMailHeader(REQUEST,name_from,email_from,name_to,email_to,subject)
            mail_text = self.postcard_text_header(REQUEST=REQUEST) + mail_text
            self._getMailHost().send(str(mail_text))
            card.AR = 0
	    return 1

    def sendPostcard(self,name_to0=None, email_to0=None,
                           name_to1=None, email_to1=None,
                           name_to2=None, email_to2=None,
                           name_to3=None, email_to3=None,
                           name_to4=None, email_to4=None,
                           name_from=None, email_from=None,
                           comment=None, size=None, REQUEST=None):
	''' verification and send '''
	message_admi=''
	if((name_to0=='') or (name_to1=='') or (name_to2=='') or (name_to3=='') or (name_to4=='') ):
		message_admi=message_admi + 'You must enter the recipients Name.'
	if((email_to0=='') or (email_to1=='') or (email_to2=='') or (email_to3=='') or (email_to4=='') ):
	    message_admi=message_admi + ' You must enter a recipients Email.'
	if(self.validEmail(email_to0)==0):
	    message_admi=message_admi + ' The recipients email is incorrect.'
	if(name_from == ''):
	    message_admi=message_admi + ' You must enter your Name.'
	if(email_from == ''):
	    message_admi=message_admi + ' You must enter your Email.'
	if(self.validEmail(email_from)==0):
	    message_admi=message_admi + ' Your email is incorrect.'
	if(comment == ''):
	    message_admi=message_admi + ' You must enter your message.'
        if REQUEST and not message_admi:
            return REQUEST.RESPONSE.redirect( '%s/postcard?zps_message=%s' % (self.absolute_url(),message_admi) )
	if REQUEST is not None:
	    times = time.strftime('%H:%M:%S %d-%m-%Y', time.localtime()) # when the postalcard is add
	    AR = REQUEST.get('AR',None)
            if AR: AR = 1
	    message_admi = 'Your PostCard was send, using the unique number: '
            
            for i in (0,1,2,3,4):
                email_to = 'email_to%s' % i
                name_to = 'name_to%s' % i
                if eval(email_to) not in (None,'') and eval(name_to) not in (None,''):
                    # create postalcard object
                    card = self.addPostcard(eval(name_to),eval(email_to),name_from,email_from,comment,times,AR,size,REQUEST)
                    # Set request
                    REQUEST = card._setRequest(REQUEST)
                    REQUEST.set('photo_url','%s' % self.absolute_url())
                    REQUEST.set('photo_id','%s' % self.getId())
                    REQUEST.set('post_type','CARD')
                    REQUEST.set('subject','You got a new postcard!')
                    # get mail header/body
                    #return REQUEST
                    mail_text = self.postcard_text_header(REQUEST=REQUEST)
                    mail_text += self.postcard_text(REQUEST=REQUEST)
                    # send postcard !
                    self._getMailHost().send(str(mail_text))
	            message_admi += ' %s, ' % card.getId()

                    # Need AR for number notification ?
                    ARref = REQUEST.get('ARref',None)
                    if ARref:
                        # get body of text before header modification
                        REQUEST.set('post_type','NOTIFICATION')
                        mail_text = self.postcard_text(REQUEST=REQUEST)
                        # header
                        name_from = 'Postcard Bot'
                        mail_from = self.getManagerMail()
                        # it's a notification: to => from
                        name_to = name_from
                        email_to = email_from
                        subject = 'The postcard was sent'
                        self._setMailHeader(REQUEST,name_from,email_from,name_to,email_to,subject)
                        mail_text = self.postcard_text_header(REQUEST=REQUEST) + mail_text
                        self._getMailHost().send(str(mail_text))
	    
        if REQUEST:
            return REQUEST.RESPONSE.redirect( '%s/zphoto_view?zps_message=%s' % (self.absolute_url(),message_admi) )

    def _getMailHost(self):
        return self.MailHost
        

class ZPostalCards(PostalCards):
    ''' The postcard system with zpt/dtml method '''

    postcard = PageTemplateFile('skins/zphotoslides/postcard',globals())
    postcard_text = PageTemplateFile('skins/zphotoslides/postcard_text',globals())
    postcard_text_header = PageTemplateFile('skins/zphotoslides/postcard_text_header',globals())

    def __init__(self):
        PostalCards.__dict__['__init__'](self)

    def _getMailHost(self):
        return self.zmailhost

