from Products.PageTemplates.PageTemplateFile import PageTemplateFile
from OFS.Folder import Folder
from Persistence import Persistent
import Acquisition

class rate(Persistent):
    """a rating"""
    def __init__(self,sessionID,id_photo,rating,comment):
      self.sessionID = sessionID
      self.id_photo  = id_photo
      self.rating    = rating
      self.comment   = comment
             
class ratings(Persistent,Acquisition.Implicit):
    """the ratings system"""
    def __init__(self):
        self.listerate = []
    def add_new(self,sessionID,id_photo,rating,comment):
        dictrate = rate(sessionID,id_photo,rating,comment)
        l = self.listerate
        l.append(dictrate)
        self.listerate = l
    def __repr__(self):
         return str(self.listerate)
    def index(self, item):
         return self.listerate.index(item)
    def __getitem__(self, i):
         return self.listerate[i]
    def __setitem__(self, i, item):
        self.listerate[i] = item
        self._p_changed = 1
    def remove(self, item):
        self.listerate.remove(item)
        self._p_changed = 1
    def empty(self):
        "Say if the rating list is empty"
        if(len(self.listerate)):
           return 1
        else:
           return 0
    def __len__(self): return len(self.listerate)
    def __delitem__(self, i):
        del self.listerate[i]
        self._p_changed = 1

class RateItem:
    ''' A ratingable item '''

    zps_ratings = PageTemplateFile('skins/zphotoslides/zps_ratings',globals())
    zps_popup = PageTemplateFile('skins/zphotoslides/zps_popup',globals())
    
    def __init__(self):
        self.show_rating = 1
        self.list_rating = ratings()
    
    def _list_rating(self):
        if not self.isPrincipiaFolderish:
            return self.aq_parent.list_rating
        else:
            return self.list_rating
    
    def doRating(self,rating=None,REQUEST=None):
      ''' Rate Content '''
      status_msg = ''
      if rating:
          sessionID = REQUEST.SESSION.get('id')
          comment = ''
          try:
              self._list_rating().add_new(sessionID,self.getId(),rating,comment)
              status_msg = 'Rating has been calculated.'
          except:
              status_msg = 'Anonymous not allowed to rate content.'
      return REQUEST.RESPONSE.redirect('%s/zps_popup?zps_message=%s' % (self.absolute_url(),status_msg) )
  
    def showRatings(self):
        ''' return 1 if object use ratings '''
        if not self.isPrincipiaFolderish:
            if hasattr(self.aq_parent,'show_rating'):
                self.show_rating = self.aq_parent.show_rating
        return self.show_rating

    def getRating(self,id=None):
	''' Print the ratings for a Photo '''
        if not id: id = self.getId()
        liste_dict = {}                             # new list
	total = 0
        for elem in self._list_rating():               # for all ratings
            if(elem.id_photo==id):                   #   if rating for the photo
	            total += 1
		    if (elem.rating not in liste_dict.keys()):
		       liste_dict[elem.rating] = 1
		    else:
		       liste_dict[elem.rating] = liste_dict[elem.rating] + 1
	for elem in liste_dict.keys():
	    liste_dict[elem] = (round((float(liste_dict[elem])/float(total))*100.0,2), liste_dict[elem])
        return liste_dict                               # we return the list
    get_rating = getRating


    def getRatingFolder(self):
        ''' Print the ratings for a folder '''
        if not self.isPrincipiaFolderish:
            return self.aq_parent.getRating()
        else:
            return self.getRating()
    get_ratingfolder = getRatingFolder

    def delRating(self,sessionID,REQUEST):
	"Delete a rating from a photo fallowing the comment date"
	for rate in self._list_rating():
		if(rate.sessionID==sessionID):
			self._list_rating().remove(rate)
			break
	if REQUEST is not None:
            message = 'Rating deleted for'+ str(sessionID)
            REQUEST.RESPONSE.redirect( '%s/manage_ratings?zps_message=%s' % (self.absolute_url(),message) )
    # seems not used
    #delete_rating = delRating
